"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.watchPostGraphQLSchema = exports.createPostGraphQLSchema = undefined;

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _graphileBuild = require("graphile-build");

var _graphileBuildPg = require("graphile-build-pg");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ensureValidPlugins = function ensureValidPlugins(name, arr) {
  if (!Array.isArray(arr)) {
    throw new Error(`Option '${name}' should be an array`);
  }
  for (var i = 0, l = arr.length; i < l; i++) {
    var fn = arr[i];
    if (typeof fn !== "function") {
      throw new Error(`Option '${name}' should be an array of functions, found '${typeof fn}' at index ${i}`);
    }
  }
};

var getPostGraphQLBuilder = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(pgConfig, schemas) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    var dynamicJson, classicIds, nodeIdFieldName, replaceAllPlugins, _options$appendPlugin, appendPlugins, _options$prependPlugi, prependPlugins, jwtPgTypeIdentifier, jwtSecret, disableDefaultMutations, graphqlBuildOptions;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            dynamicJson = options.dynamicJson, classicIds = options.classicIds, nodeIdFieldName = options.nodeIdFieldName;
            replaceAllPlugins = options.replaceAllPlugins, _options$appendPlugin = options.appendPlugins, appendPlugins = _options$appendPlugin === undefined ? [] : _options$appendPlugin, _options$prependPlugi = options.prependPlugins, prependPlugins = _options$prependPlugi === undefined ? [] : _options$prependPlugi, jwtPgTypeIdentifier = options.jwtPgTypeIdentifier, jwtSecret = options.jwtSecret, disableDefaultMutations = options.disableDefaultMutations, graphqlBuildOptions = options.graphqlBuildOptions;

            if (replaceAllPlugins) {
              ensureValidPlugins("replaceAllPlugins", replaceAllPlugins);
            }
            ensureValidPlugins("prependPlugins", prependPlugins);
            ensureValidPlugins("appendPlugins", appendPlugins);
            return _context.abrupt("return", (0, _graphileBuild.getBuilder)(replaceAllPlugins ? [].concat((0, _toConsumableArray3.default)(prependPlugins), (0, _toConsumableArray3.default)(replaceAllPlugins), (0, _toConsumableArray3.default)(appendPlugins)) : [].concat((0, _toConsumableArray3.default)(prependPlugins), (0, _toConsumableArray3.default)(_graphileBuild.defaultPlugins), (0, _toConsumableArray3.default)(_graphileBuildPg.defaultPlugins), (0, _toConsumableArray3.default)(appendPlugins)), (0, _assign2.default)({
              pgConfig: pgConfig,
              pgSchemas: Array.isArray(schemas) ? schemas : [schemas],
              pgExtendedTypes: !!dynamicJson,
              pgInflection: classicIds ? _graphileBuildPg.inflections.postGraphQLClassicIdsInflection : _graphileBuildPg.inflections.postGraphQLInflection,
              nodeIdFieldName: nodeIdFieldName || (classicIds ? "id" : "nodeId"),
              pgJwtTypeIdentifier: jwtPgTypeIdentifier,
              pgJwtSecret: jwtSecret,
              pgDisableDefaultMutations: disableDefaultMutations
            }, graphqlBuildOptions)));

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function getPostGraphQLBuilder(_x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var createPostGraphQLSchema = exports.createPostGraphQLSchema = function () {
  var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(pgConfig, schemas) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var builder;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return getPostGraphQLBuilder(pgConfig, schemas, options);

          case 2:
            builder = _context2.sent;
            return _context2.abrupt("return", builder.buildSchema());

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function createPostGraphQLSchema(_x5, _x6) {
    return _ref2.apply(this, arguments);
  };
}();

/*
 * Unless an error occurs, `onNewSchema` is guaranteed to be called before this promise resolves
 */
var watchPostGraphQLSchema = exports.watchPostGraphQLSchema = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(pgConfig, schemas) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var onNewSchema = arguments[3];
    var builder, released;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            if (!(typeof onNewSchema !== "function")) {
              _context4.next = 2;
              break;
            }

            throw new Error("You cannot call watchPostGraphQLSchema without a function to pass new schemas to");

          case 2:
            _context4.next = 4;
            return getPostGraphQLBuilder(pgConfig, schemas, options);

          case 4:
            builder = _context4.sent;
            released = false;
            _context4.next = 8;
            return builder.watchSchema(onNewSchema);

          case 8:
            return _context4.abrupt("return", function () {
              var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
                return _regenerator2.default.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        if (!released) {
                          _context3.next = 2;
                          break;
                        }

                        return _context3.abrupt("return");

                      case 2:
                        released = true;
                        _context3.next = 5;
                        return builder.unwatchSchema();

                      case 5:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3, this);
              }));

              function release() {
                return _ref4.apply(this, arguments);
              }

              return release;
            }());

          case 9:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));

  return function watchPostGraphQLSchema(_x8, _x9) {
    return _ref3.apply(this, arguments);
  };
}();
//# sourceMappingURL=index.js.map